\ Forth utilities

" leonardoce.forth.vm.primitives.ReturnPrimitive" constant (RETURNPRIM)
" leonardoce.forth.vm.primitives.StaticCall" constant (CALLPRIM)
" leonardoce.forth.vm.primitives.sys.Comment" constant (COMMENTPRIM)

: (dump-ok-prim) ( a -- )
    dup .      \ Print address
    space
    @ . space  \ Print contents
    ;

: dump ( a n -- )
    over + swap
    cr
    do
        i (dump-ok-prim) cr
    loop ;

: reset 
  begin
    length 0 = if leave else drop then
  repeat ;

: jinvoke0 0 jinvoken ;

: jinvoke1 1 jinvoken ;

: string= ( s1 s2 -- f )
    " equals" jinvoke1 jbool>int ;

: (isprimtype?) ( type a -- f )
    @ >classname string= ;

: (isretprim?) ( a -- f )
    (RETURNPRIM) swap (isprimtype?) ;

: (iscallprim?) ( a -- f )
    (CALLPRIM) swap (isprimtype?)  ;

: (iscommentprim?) ( a -- f )
    (COMMENTPRIM) swap (isprimtype?) ;

: (dump-call-prim) ( a -- )
    @ " getDestination" jinvoke0 
    dup (iscommentprim?) if 
        ." (" 
        @ " getContents" jinvoke0 .
        ." )"
    else 
        drop 
    then ;

: (dump-prim) ( a -- ) 
    dup (dump-ok-prim) 
    dup (iscallprim?) if (dump-call-prim) else drop then ;
    
: see ( <word> -- )
    '
    cr
    begin
        dup (dump-prim) cr
        dup (isretprim?) if drop leave then
        1+
    repeat ;