/*
 * Compiler.java
 *
 * Created on 17 agosto 2007, 20.13
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.compiler;

import java.io.IOException;
import java.io.InputStream;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.ForthInputStream;

/**
 *
 * @author leonardo
 */
public class LexicalAnalyzer {
    private ForthInputStream _is;
    
    public void setInputStream(ForthInputStream is) {
        _is=is;
    }
    
    private boolean isInteger(String x)
    {
        try
        {
            Integer.parseInt(x);
            return true;
        } catch(NumberFormatException nfe)
        {
            return false;
        }
    }
        
    private boolean isDouble(String x)
    {
        try
        {
            Double.parseDouble(x);
            return true;
        } catch(NumberFormatException nfe)
        {
            return false;
        }
    }
    
    public Token read() throws ForthException {
        String w=_is.readWord();
        if(w==null || w.length()==0)
        {
            return null;
        } else if(isInteger(w))
        {
            return new IntToken(w);
        } else if(isDouble(w))
        {
            return new DoubleToken(w);
        } else {
            // Maybe it's a word?
            return new WordToken(w);
        }
    }
}
