/*
 * WordToken.java
 *
 * Created on 17 agosto 2007, 20.25
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.compiler;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.ForthVm;
import leonardoce.forth.vm.Memory;
import leonardoce.forth.UnknownWordException;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.StaticCall;
import leonardoce.forth.vm.primitives.StaticJump;
import leonardoce.forth.vm.primitives.StaticPushRet;

/**
 *
 * @author leonardo
 */
public class WordToken implements Token {
    private String _w;
    
    /** Creates a new instance of WordToken */
    public WordToken(String w) {
        _w=w;
    }

    public void compile(VmStatus vm) throws ForthException {
        if(vm.getCurrentDictionary().hasWord(_w))
        {
            int xt=vm.getCurrentDictionary().getExecutionToken(_w);
            boolean immediate=vm.getCurrentDictionary().isImmediate(_w);
            
            if(immediate) {
                int previous=vm.getHere();
                new StaticPushRet(-1).execute(vm);
                new StaticJump(xt).execute(vm);
                ForthVm fvm=new ForthVm(vm);
                while(vm.getProgramCounter()!=-1)
                {
                    fvm.executeOneStep();
                }
                vm.setProgramCounter(previous);
            } else {
                Memory m=vm.getCurrentMemory();
                m.store(vm.getHere(), new StaticCall(xt));
                vm.setHere(vm.getHere()+1);
            }
        } else
        {
            throw new UnknownWordException(_w);
        }
    }    
    
    
    public void execute(VmStatus vm) throws ForthException {
        if(vm.getCurrentDictionary().hasWord(_w))
        {
            int xt=vm.getCurrentDictionary().getExecutionToken(_w);
            
            int previous=vm.getHere();
            new StaticPushRet(-1).execute(vm);
            new StaticJump(xt).execute(vm);
            ForthVm fvm=new ForthVm(vm);
            while(vm.getProgramCounter()!=-1)
            {
                fvm.executeOneStep();
            }
            vm.setProgramCounter(previous);
        } else
        {
            throw new UnknownWordException(_w);
        }
    }
}
