/*
 * ForthEditorController.java
 *
 * Created on 20 agosto 2007, 16.52
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author leonardo
 */
public class ForthEditorController {
    private ForthEditorView view;
    private final static String NONAME_TITLE="<noname>";
    
    public ForthEditorController(ForthEditorView fev) {
        fev.setController(this);
        view=fev;
        view.createNewTab();
        view.setCurrentTabTitle(NONAME_TITLE);
    }
 
    public void newFile() {
        view.createNewTab();
        view.setCurrentTabTitle(NONAME_TITLE);
    }
    
    public void loadFile(File f) {
        StringBuffer sb=new StringBuffer();
        try {
            FileReader fr=new FileReader(f);
            char buffer[]=new char[1024];
            while(true) {
                int read=fr.read(buffer);
                if(read<=0) {
                    break;
                }
                sb.append(buffer, 0, read);
            }
            fr.close();
            
            if(view.getCurrentTabFile()!=null || view.getText().length()>0) {
                view.createNewTab();
            }
            
            view.setText(sb.toString());
            view.setCurrentTabTitle(f.getName());
            view.setCurrentTabFile(f);
        } catch(IOException ioe) {
            view.showErrorMessage(ioe.toString());
            ioe.printStackTrace();
        }
    }

    public void saveFile() {
        if(view.getCurrentTabFile()!=null) {
            saveFile(view.getCurrentTabFile());
        }
    }
    
    public void saveFile(File f) {
        try {
            FileWriter fw=new FileWriter(f);
            fw.write(view.getText());
            fw.close();
            
            view.setCurrentTabTitle(f.getName());
            view.setCurrentTabFile(f);
        } catch(IOException ioe) {
            view.showErrorMessage(ioe.toString());
            ioe.printStackTrace();
        }        
    }
    
    public void closeFile() {
        view.deleteActiveTab();
    }
    
    public void signalChanged() {
        if(!view.getCurrentTabTitle().endsWith("*")) {
            view.setCurrentTabTitle(view.getCurrentTabTitle()+" *");
        }
    }
    
    public boolean isChanged() {
        for(String s: view.getTabTitles()) {
            if(s!=null && s.endsWith("*")) {
                return true;
            }
        }
        return false;
    }
    
    public String getContents() {
        return view.getText();
    }
    
    public void requestFocus() {
        view.requestFocus();
    }
    
    public File getActiveFile() {
        return view.getCurrentTabFile();
    }
}
