/*
 * ForthGuiController.java
 *
 * Created on 20 agosto 2007, 16.27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui;

import java.io.File;
import java.io.FileNotFoundException;

/**
 *
 * @author leonardo
 */
public class ForthGuiController {
    private ForthGuiView view;
    private int nextFocus=1;
    
    /** Creates a new instance of ForthGuiController */
    public ForthGuiController(ForthGuiView fgv) {
        fgv.setController(this);
        view=fgv;
        view.setTitle("LeoForth");
    }
    
    public void exit() {
        if(view.getEditorController().isChanged() && 
                !view.showConfirmDialog("There are unsaved informations. Do you want to lose changes?")) {
            return;
        }
        
        System.exit(0);
    }
    
    public void save() {
        if(view.getEditorController().getActiveFile()!=null) {
            view.getEditorController().saveFile();
        } else {
            saveAs();
        }
    }
    
    public void saveAs() {
        String defaultName=view.getEditorController().getActiveFile()!=null?view.getEditorController().getActiveFile().toString():"";
        String fileName=view.showSaveFileDialog(defaultName);
        
        if(fileName==null || fileName.length()==0) {
            return;
        }
        
        File f=new File(fileName);
        view.getEditorController().saveFile(f);
    }
    
    public void open() {
        String fileName=view.showOpenFileDialog();
        if(fileName==null || fileName.length()==0) {
            return;
        }
        
        File f=new File(fileName);
        view.getEditorController().loadFile(f);
    }
    
    public void newAction() {
        view.getEditorController().newFile();
    }
    
    public void close() {
        if(view.getEditorController().isChanged() && !view.showConfirmDialog("There are unsaved informations. Do you want to lose changes?")) {
            return;
        }
        
        view.getEditorController().closeFile();
    }
    
    public void compile() {
        view.getInteractorController().executeForthCode(view.getEditorController().getContents());
    }
    
    public void switchFocus() {
        if(nextFocus==1) {
            view.getEditorController().requestFocus();
        } else {
            view.getInteractorController().requestFocus();
        }
        nextFocus=-nextFocus;
    }
}
