/*
 * ForthGuiController.java
 *
 * Created on 18 agosto 2007, 14.44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui;

import java.io.StringReader;
import leonardoce.forth.ForthException;
import leonardoce.forth.LeoForth;
import leonardoce.forth.boot.BootVmStatus;
import leonardoce.forth.vm.ForthOutputStream;
import leonardoce.forth.vm.ReaderAdaptor;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class ForthInteractorController {
    private VmStatus vm;
    private LeoForth lf;
    private ForthInteractorView view;
        
    public ForthInteractorController(ForthInteractorView _view) {
        vm=new BootVmStatus();
        lf=new LeoForth(vm);
        vm.setForthOutputStream(new InternalOutputStream());
        view=_view;
        view.setController(this);
    }
    
    public void enterPressed() {
        String txt=view.getNewInput().trim();
        if(txt.length()==0) {
            return;
        }
        executeForthCode(txt);
    }

    public void executeForthCode(final String txt) {
        
        StringReader sr=new StringReader(txt);
        vm.setInputStream(new ReaderAdaptor(sr));
        view.addToOutput(" ");
        try {
            lf.run();
        } catch (Exception ex) {
            view.showError(ex.toString());
            ex.printStackTrace();
        }        
        view.addToOutput(" ok\n");
    }
    
    public void requestFocus() {
        view.requestFocus();
    }
    
    class InternalOutputStream implements ForthOutputStream {
        public void putObject(Object o) {
            if(o==null) {
                view.addToOutput("null");
            } else {
                view.addToOutput(o.toString());
            }
        }        
    }
}
