/*
 * SyntaxPane.java
 *
 * Created on 20 agosto 2007, 17.11
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.gui.swing;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.swing.plaf.*;
import java.util.*;
import java.util.regex.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author leonardo
 */
public class ForthSyntaxPane  extends JEditorPane implements CaretListener {
    private SimpleAttributeSet commentStyle, contentStyle;
    
    public ForthSyntaxPane() {
        super();
        setEditorKit(new ForthEditorKit());
        
        commentStyle = new SimpleAttributeSet();
        StyleConstants.setForeground(commentStyle, Color.BLUE);
        StyleConstants.setBold(commentStyle, true);
        
        contentStyle = new SimpleAttributeSet();
        StyleConstants.setForeground(contentStyle, Color.BLACK);
        StyleConstants.setBold(contentStyle, false);

        addCaretListener(this);
    }
    
    public void setMarks(int offset, int len) {
        //SwingUtilities.invokeLater(new StyleUpdater(offset, len));
    }
    
    public boolean getScrollableTracksViewportWidth() {
        return false;
    }
    
    public void setSize(Dimension d) {
        if(d.width < getParent().getSize().width) {
            d.width = getParent().getSize().width;
        }
        super.setSize(d);
    }
    
    private class StyleUpdater implements Runnable {
        public StyleUpdater(int offset, int len) {
            this.sDoc = (StyledDocument)ForthSyntaxPane.this.getDocument();
            this.offset = offset;
            this.len = len;
        }
        
        public void run() {
            if(sDoc.getLength()==0) {
                return;
            }

            ForthSyntaxPane.this.removeCaretListener(ForthSyntaxPane.this);

            try {
                sDoc.setCharacterAttributes(offset, len, contentStyle, true);
                
                String text = sDoc.getText(offset, len)+"\n";
                char[] textA=text.toCharArray();
                
                boolean inComment=false;
                int commentStart=0;
                for(int i=0;i<text.length();i++) {
                    if(textA[i]=='\\') {
                        inComment=true;
                        commentStart=i;
                    } else if(textA[i]=='\n' && inComment) {
                        sDoc.setCharacterAttributes(commentStart+offset, i-commentStart, commentStyle, true);
                        inComment=false;
                    }
                }
                if(text != null && text.length() > 0) {
                    int idx=text.indexOf('\\');
                    if(idx!=-1) {
                        
                    }
                }
            } catch (Exception ex) {
                System.out.println("StyleUpdater ERROR: " + ex.getMessage());
            }
            
            ForthSyntaxPane.this.addCaretListener(ForthSyntaxPane.this);
            
        }
        
        private StyledDocument sDoc;
        private int offset;
        private int len;
    }
    
    public void caretUpdate(CaretEvent e) {
        StyledDocument sDoc = (StyledDocument) getDocument();
        int cPos = e.getDot();
        int length = sDoc.getLength();
        String text="";
        
        try {
            text = sDoc.getText(0, length);
        } catch (BadLocationException ex) {
            ex.printStackTrace();
            return;
        }
        int lineStart = text.substring(0, cPos).lastIndexOf("\n") + 1;
        int lineEnd = text.indexOf("\n", cPos);
        if(lineEnd < 0) {
            lineEnd = length;
        }
        setMarks(lineStart, lineEnd - lineStart);
    }
    
    public void setText(String t) {
        removeCaretListener(this);
        super.setText(t);
        StyledDocument sDoc = (StyledDocument) getDocument();
        setMarks(0, sDoc.getLength());
        setCaretPosition(0);
        addCaretListener(this);
    }
    
}
