/*
 * SwingForthGui.java
 *
 * Created on 20 agosto 2007, 16.23
 */

package leonardoce.forth.gui.swing;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.KeyStroke;
import leonardoce.forth.gui.ForthEditorController;
import leonardoce.forth.gui.ForthGuiController;
import leonardoce.forth.gui.ForthGuiView;
import leonardoce.forth.gui.ForthInteractorController;

/**
 *
 * @author  leonardo
 */
public class SwingForthGui extends javax.swing.JFrame implements ForthGuiView {
    private ForthGuiController controller;
    private ForthInteractorController interactorController;
    private ForthEditorController editorController;
    
    /** Creates new form SwingForthGui */
    public SwingForthGui() {
        initComponents();
        interactorController=new ForthInteractorController(swingForthInteractor1);
        editorController=new ForthEditorController(swingForthEditor1);
        
        jSplitPane1.setDividerLocation(0.8);
        
        miNew.setAction(new NewAction());
        toolBar.add(miNew.getAction());
        
        toolBar.addSeparator();
        
        miOpen.setAction(new OpenAction());
        toolBar.add(miOpen.getAction());

        miClose.setAction(new CloseAction());
        toolBar.add(miClose.getAction());
        
        miSave.setAction(new SaveAction());
        toolBar.add(miSave.getAction());
        
        miSaveAs.setAction(new SaveAsAction());
        toolBar.add(miSaveAs.getAction());

        toolBar.addSeparator();
                
        miCompile.setAction(new CompileAction());
        toolBar.add(miCompile.getAction());
        
        miInteraction.setAction(new SwitchInteactionArea());
        toolBar.add(miInteraction.getAction());
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jSplitPane1 = new javax.swing.JSplitPane();
        swingForthInteractor1 = new leonardoce.forth.gui.swing.SwingForthInteractor();
        swingForthEditor1 = new leonardoce.forth.gui.swing.SwingForthEditor();
        toolBar = new javax.swing.JToolBar();
        jMenuBar1 = new javax.swing.JMenuBar();
        mnuFile = new javax.swing.JMenu();
        miNew = new javax.swing.JMenuItem();
        jSeparator2 = new javax.swing.JSeparator();
        miOpen = new javax.swing.JMenuItem();
        miClose = new javax.swing.JMenuItem();
        miSave = new javax.swing.JMenuItem();
        miSaveAs = new javax.swing.JMenuItem();
        jSeparator1 = new javax.swing.JSeparator();
        miExit = new javax.swing.JMenuItem();
        mnuForth = new javax.swing.JMenu();
        miCompile = new javax.swing.JMenuItem();
        miInteraction = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jSplitPane1.setOrientation(javax.swing.JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setRightComponent(swingForthInteractor1);

        jSplitPane1.setLeftComponent(swingForthEditor1);

        mnuFile.setText("File");
        miNew.setText("Item");
        mnuFile.add(miNew);

        mnuFile.add(jSeparator2);

        mnuFile.add(miOpen);

        miClose.setText("Item");
        mnuFile.add(miClose);

        mnuFile.add(miSave);

        mnuFile.add(miSaveAs);

        mnuFile.add(jSeparator1);

        miExit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/leonardoce/forth/gui/swing/res/Stop24.gif")));
        miExit.setText("Exit");
        miExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                miExitActionPerformed(evt);
            }
        });

        mnuFile.add(miExit);

        jMenuBar1.add(mnuFile);

        mnuForth.setText("Forth");
        miCompile.setText("Item");
        mnuForth.add(miCompile);

        miInteraction.setText("Item");
        mnuForth.add(miInteraction);

        jMenuBar1.add(mnuForth);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(toolBar, javax.swing.GroupLayout.DEFAULT_SIZE, 551, Short.MAX_VALUE)
            .addComponent(jSplitPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 551, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(toolBar, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 550, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        controller.exit();
    }//GEN-LAST:event_formWindowClosing

    private void miExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_miExitActionPerformed
        controller.exit();
    }//GEN-LAST:event_miExitActionPerformed
 
    public ForthGuiController getController() {
        return controller;
    }

    public void setController(ForthGuiController controller) {
        this.controller = controller;
    }

    public ForthInteractorController getInteractorController() {
        return interactorController;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JSeparator jSeparator2;
    private javax.swing.JSplitPane jSplitPane1;
    private javax.swing.JMenuItem miClose;
    private javax.swing.JMenuItem miCompile;
    private javax.swing.JMenuItem miExit;
    private javax.swing.JMenuItem miInteraction;
    private javax.swing.JMenuItem miNew;
    private javax.swing.JMenuItem miOpen;
    private javax.swing.JMenuItem miSave;
    private javax.swing.JMenuItem miSaveAs;
    private javax.swing.JMenu mnuFile;
    private javax.swing.JMenu mnuForth;
    private leonardoce.forth.gui.swing.SwingForthEditor swingForthEditor1;
    private leonardoce.forth.gui.swing.SwingForthInteractor swingForthInteractor1;
    private javax.swing.JToolBar toolBar;
    // End of variables declaration//GEN-END:variables
    
    private class NewAction extends AbstractAction {
        public NewAction() {
            super("New", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/New24.gif")));
            putValue(this.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control N"));
        }

        public void actionPerformed(ActionEvent e) {
            controller.newAction();
        }
    }
    
    private class OpenAction extends AbstractAction {
        public OpenAction() {
            super("Open", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/Open24.gif")));
            putValue(this.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control O"));
        }

        public void actionPerformed(ActionEvent e) {
            controller.open();
        }
    }
    
    private class CloseAction extends AbstractAction {
        public CloseAction() {
            super("Close", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/Close24.gif")));
        }

        public void actionPerformed(ActionEvent e) {
            controller.close();
        }
    }
    
    private class CompileAction extends AbstractAction {
        public CompileAction() {
            super("Compile", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/Play24.gif")));
            putValue(this.ACCELERATOR_KEY, KeyStroke.getKeyStroke("F5"));
        }

        public void actionPerformed(ActionEvent e) {
            controller.compile();
        }
    }    

    private class SaveAction extends AbstractAction {
        public SaveAction() {
            super("Save", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/Save24.gif")));
            putValue(this.ACCELERATOR_KEY, KeyStroke.getKeyStroke("control S"));
        }

        public void actionPerformed(ActionEvent e) {
            controller.save();
        }
    }

    private class SaveAsAction extends AbstractAction {
        public SaveAsAction() {
            super("Save As", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/SaveAs24.gif")));
        }

        public void actionPerformed(ActionEvent e) {
            controller.saveAs();
        }
    }

    private class SwitchInteactionArea extends AbstractAction {
        public SwitchInteactionArea() {
            super("Change Interaction Area", new javax.swing.ImageIcon(SwingForthGui.class.getResource("/leonardoce/forth/gui/swing/res/History24.gif")));
            putValue(this.ACCELERATOR_KEY, KeyStroke.getKeyStroke("F9"));
        }

        public void actionPerformed(ActionEvent e) {
            controller.switchFocus();
        }
    }
    
    public ForthEditorController getEditorController() {
        return editorController;
    }

    public String showOpenFileDialog() {
        JFileChooser jfc=new JFileChooser();
        
        if(jfc.showOpenDialog(this)==JFileChooser.APPROVE_OPTION) {
            return jfc.getSelectedFile().getAbsolutePath();
        } else {
            return null;
        }
    }

    public String showSaveFileDialog(String defaultFileName) {
        JFileChooser jfc=new JFileChooser(defaultFileName);
        jfc.setSelectedFile(new java.io.File(defaultFileName));
        
        if(jfc.showSaveDialog(this)==JFileChooser.APPROVE_OPTION) {
            return jfc.getSelectedFile().getAbsolutePath();
        } else {
            return null;
        }
    }

    public boolean showConfirmDialog(String msg) {
        return JOptionPane.showConfirmDialog(this, msg, "LeoForth", 
                JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE)==
                JOptionPane.YES_OPTION;
    }

    public void showErrorMessage(String msg) {
        JOptionPane.showMessageDialog(this, msg, "LeoForth", JOptionPane.ERROR_MESSAGE);
    }
}
