/*
 * SwingInteractor.java
 *
 * Created on 18 agosto 2007, 15.13
 */

package leonardoce.forth.gui.swing;

import java.awt.Color;
import java.awt.FocusTraversalPolicy;
import java.awt.Toolkit;
import java.util.Vector;
import javax.swing.DefaultComboBoxModel;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyledDocument;

/**
 *
 * @author  leonardo
 */
public class SwingInteractor extends javax.swing.JPanel {
    private Vector<InteractorListener> listeners;
    private Style inputStyle, outputStyle, errorStyle;
    private StyledDocument document;
    private static final int OLD_INPUT_SIZE=5;
    
    /** Creates new form SwingInteractor */
    public SwingInteractor() {
        initComponents();
        
        listeners=new Vector<InteractorListener>();
        
        document=taInteraction.getStyledDocument();
        inputStyle=document.addStyle("inputStyle", null);
        outputStyle=document.addStyle("outputStyle", null);
        errorStyle=document.addStyle("errorStyle", null);
        
        inputStyle.addAttribute(StyleConstants.Foreground, new Color(0,100,0));
        inputStyle.addAttribute(StyleConstants.Bold, true);
        outputStyle.addAttribute(StyleConstants.Foreground, Color.black);
        errorStyle.addAttribute(StyleConstants.Foreground, Color.red);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane1 = new javax.swing.JScrollPane();
        taInteraction = new javax.swing.JTextPane();
        tfInput = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        btClear = new javax.swing.JButton();

        jScrollPane1.setFocusable(false);
        taInteraction.setBackground(new java.awt.Color(255, 255, 204));
        taInteraction.setEditable(false);
        taInteraction.setFont(new java.awt.Font("Courier New", 0, 14));
        taInteraction.setFocusable(false);
        jScrollPane1.setViewportView(taInteraction);

        tfInput.setBackground(new java.awt.Color(200, 250, 200));
        tfInput.setFont(new java.awt.Font("Courier New", 0, 14));
        tfInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                tfInputActionPerformed(evt);
            }
        });

        jLabel1.setText("Forth>");
        jLabel1.setFocusable(false);

        btClear.setIcon(new javax.swing.ImageIcon(getClass().getResource("/leonardoce/forth/gui/swing/res/Delete24.gif")));
        btClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btClearActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tfInput, javax.swing.GroupLayout.DEFAULT_SIZE, 279, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btClear))
            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 410, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 267, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel1)
                        .addComponent(tfInput, javax.swing.GroupLayout.PREFERRED_SIZE, 34, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(btClear)))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void btClearActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btClearActionPerformed
        try {
            document.remove(0, document.getLength());
        } catch(BadLocationException e) {
            e.printStackTrace();
        }
    }//GEN-LAST:event_btClearActionPerformed

    private void tfInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_tfInputActionPerformed
        signalEnterPressed();
    }//GEN-LAST:event_tfInputActionPerformed
    
    public String getNewInput() {
        String txt=tfInput.getText();
        tfInput.setText("");
        
        try {
            document.insertString(document.getLength(), txt, document.getStyle("inputStyle"));    
        } catch (BadLocationException ex) {
            ex.printStackTrace();
        }    
        
        return txt;
    }
    
    public void appendNewOutput(String str) {
        try {
            document.insertString(document.getLength(), str, document.getStyle("outputStyle"));    
        } catch (BadLocationException ex) {
            ex.printStackTrace();
        }    
    }
    
    public void appendNewError(String str) {
        try {
            document.insertString(document.getLength(), str, document.getStyle("errorStyle"));    
        } catch (BadLocationException ex) {
            ex.printStackTrace();
        }    
    }
    
    public void addInteractorListener(InteractorListener il)
    {
        listeners.addElement(il);
    }
    
    public void removeInteractorListener(InteractorListener il)
    {
        listeners.removeElement(il);
    }
    
    private void signalEnterPressed() {
        for(InteractorListener il: listeners) {
            il.enterPressed();
        }
    }

    public void requestFocus() {
        tfInput.requestFocus();
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btClear;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane taInteraction;
    private javax.swing.JTextField tfInput;
    // End of variables declaration//GEN-END:variables
    
}
