/*
 * BootVmStatus.java
 *
 * Created on 17 agosto 2007, 21.06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm;

import java.io.InputStream;
import java.util.Stack;

/**
 *
 * @author leonardo
 */
public class DefaultVmStatus implements VmStatus {
    private ForthInputStream _is;
    private ForthOutputStream _os;
    private Dictionary _v;
    private Memory _m;
    private Stack<Object> dataStack, returnStack, controlStack;
    private int _pc, _here;
    private boolean _active, _compiling;
    
    /** Creates a new instance of BootVmStatus */
    public DefaultVmStatus() {
        _is=null;
        _v=new Dictionary();
        _m=new Memory();
        _active=true;
        _compiling=false;
        dataStack=new Stack<Object>();
        returnStack=new Stack<Object>();
        controlStack=new Stack<Object>();
    }

    public ForthInputStream getInputStream()
    {
        return _is;
    }
    
    public void setInputStream(ForthInputStream v)
    {
        _is=v;
    }

    public Dictionary getCurrentDictionary() {
        return _v;
    }

    public Memory getCurrentMemory() {
        return _m;
    }

    public Stack<Object> getDataStack() {
        return dataStack;
    }

    public Stack<Object> getReturnStack() {
        return returnStack;
    }

    public int getProgramCounter() {
        return _pc;
    }

    public void setProgramCounter(int pc) {
        _pc=pc;
    }

    public int getHere() {
        return _here;
    }

    public void setHere(int h) {
        _here=h;
    }

    public boolean isActive() {
        return _active;
    }
    
    public void setActive(boolean act)
    {
        _active=act;
    }

    public boolean isCompiling() {
        return _compiling;
    }

    public void setCompiling(boolean stat) {
        _compiling=stat;
    }
    
    public String dump() {
        StringBuffer sb=new StringBuffer();
        sb.append("Memory dump:\n");
        sb.append("------------\n");
        sb.append(getCurrentMemory().dump()+"\n\n");
        sb.append("Vocabulary dump:\n");
        sb.append("----------------\n");
        sb.append(getCurrentDictionary().dump()+"\n\n");
        sb.append("PC: ");
        sb.append(getProgramCounter());
        sb.append("\n");
        sb.append("Here: ");
        sb.append(getHere());
        sb.append("\n");
        return sb.toString();
    }

    public ForthOutputStream getForthOutputStream() {
        return _os;
    }

    public void setForthOutputStream(ForthOutputStream fos) {
        _os=fos;
    }

    public Stack<Object> getControlStack() {
        return controlStack;
    }
}
