/*
 * Return.java
 *
 * Created on 17 agosto 2007, 21.36
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.sys.Jump;

/**
 *
 * @author leonardo
 */
public class StaticCall extends AbstractPrimitive {
    private int _xt;
    /** Creates a new instance of Return */
    public StaticCall(int xt) {
        _xt=xt;
    }

    public void execute(VmStatus is) throws ForthException {
        // Pc is already avanced...
        new StaticPushRet(is.getProgramCounter()).execute(is);
        new StaticJump(_xt).execute(is);
    }

    public String getName() {
        return "call "+_xt;
    }
    
    public String getDocumentation() {
        return "This is an internal primitive and doesn't corrispond to any forth word";
    }
    
    public int getDestination() {
        return _xt;
    }
}
