/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.cflow;
import java.util.Stack;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.StackMarker;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.StaticJump;
import leonardoce.forth.vm.primitives.StaticJumpZero;
import leonardoce.forth.vm.primitives.sys.Comment;

/**
 * TODO
 * @author leonardo
 */
public class RepeatPrim extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public RepeatPrim() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("\"repeat\" is valid only in compiler mode");
        }
        
        int beginAddr=-1;
        Stack<Object> unHandled=new Stack<Object>();
        while(true)
        {
            Object o=is.getControlStack().pop();
            boolean handled=false;
            
            if(o instanceof StackMarker)
            {
                StackMarker sm=(StackMarker)o;
                if(sm.getMarkerType().equals("leave")) {
                    is.getCurrentMemory().store(sm.getAddress(), new StaticJump(is.getHere()+1));
                    handled=true;
                } else if(sm.getMarkerType().equals("begin")) {
                    beginAddr=sm.getAddress();
                    handled=true;
                    break;
                }
            }
            
            if(!handled)
            {
            }
        }
        
        if(beginAddr==-1) {
            throw new ForthException("Misplaced begin/repeat");
        }
        
        is.getCurrentMemory().store(is.getHere(), new StaticJump(beginAddr));
        is.setHere(is.getHere()+1);
        
        while(!unHandled.isEmpty()) {
            is.getControlStack().push(unHandled.pop());
        }
    }
    
    public String getName()
    {
        return "repeat";
    }  
    
    public boolean isImmediate() {
        return true;
    }

    public String getDocumentation() {
        return "This is the end of the \"begin\"--\"repeat\" control structure";
    }
}
