/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.cflow;
import java.util.Stack;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.StackMarker;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.StaticJump;
import leonardoce.forth.vm.primitives.StaticJumpZero;
import leonardoce.forth.vm.primitives.sys.Comment;

/**
 * TODO
 * @author leonardo
 */
public class ThenPrim extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public ThenPrim() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("\"then\" is valid only in compiler mode");
        }
        
        int elseAddr=-1;
        int ifAddr=-1;
        Stack<Object> unHandled=new Stack<Object>();
        while(true)
        {
            Object o=is.getControlStack().pop();
            boolean handled=false;
            
            if(o instanceof StackMarker)
            {
                StackMarker sm=(StackMarker)o;
                if(sm.getMarkerType().equals("else")) {
                    elseAddr=sm.getAddress();
                    handled=true;
                } else if(sm.getMarkerType().equals("if")) {
                    ifAddr=sm.getAddress();
                    handled=true;
                    break;
                }
            }
            
            if(!handled)
            {
                unHandled.push(o);
            }
        }

        if(ifAddr==-1)
        {
            throw new ForthException("Misplaced if/then/else");
        }        
        
        // Compile the if keyword
        if(elseAddr==-1)
        {
            // Simply insert a jump to here
            is.getCurrentMemory().store(ifAddr, new StaticJumpZero(is.getHere()));
        } else
        {
            // Insert a jump next to the else brench
            is.getCurrentMemory().store(ifAddr, new StaticJumpZero(elseAddr+1));
            // At the else insert a jump to here
            is.getCurrentMemory().store(elseAddr, new StaticJump(is.getHere()));
        }
        
        // Restore the unhandled markers
        while(!unHandled.empty()) {
            is.getControlStack().push(unHandled.pop());
        }
    }
    
    public String getName()
    {
        return "then";
    }  
    
    public boolean isImmediate() {
        return true;
    }
    
    public String getDocumentation() {
        return "immediate\nThe \"then\" brench for the \"if\" control structure. Please see \"if\" and \"else\"";
    }
}
