/*
 * Minus.java
 *
 * Created on 17 agosto 2007, 22.46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.obj;

import java.lang.reflect.Constructor;
import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;

/**
 *
 * @author leonardo
 */
public class JNewN extends AbstractPrimitive {
    
    /** Creates a new instance of Plus */
    public JNewN() {
    }

    public void execute(VmStatus is) throws ForthException {
        Integer nArgs=(Integer)is.getDataStack().pop();
        String className=(String)is.getDataStack().pop();
        
        Object[] args=new Object[nArgs];
        for(int i=args.length-1;i>=0;i--) {
            args[i]=is.getDataStack().pop();
        }
        
        try {
            Class<?> t=Class.forName(className);
            
            Constructor<?> cons=null;
            
            // Try an exact match and, if it doesn't work, 
            // try to match the number of arguments
            try {
                Class<?>[] argsClasses=new Class<?>[nArgs];
                for(int i=0;i<args.length;i++) {
                    if(args[i]==null) {
                        argsClasses[i]=Object.class;
                    } else {
                        argsClasses[i]=args[i].getClass();
                    }
                }
                
                cons=t.getConstructor(argsClasses);
            } catch(NoSuchMethodException nse) {
                Constructor<?>[] constructors=t.getConstructors();
                for(int i=0;i<constructors.length;i++) {
                    int p=constructors[i].getParameterTypes().length;
                    if(constructors[i].getParameterTypes().length==nArgs) {
                        cons=constructors[i];
                    }
                }
            }
            
            if(cons==null) {
                throw new ForthException("Can't find constructor for class \""+t+"\" and \""+nArgs+"\" formal parameters");
            } 
            
            is.getDataStack().push(cons.newInstance(args));
        } catch(Exception e) {
            throw new ForthException(e);
        }
        
    }
    
    public String getName()
    {
        return "jnewn";
    }  

    public String getDocumentation() {
        return "( arg1...argn classname n-args -- obj )\nCreate a new java class using a constructor with\nthe specified arguments";
    }
}
