/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class BracketTick extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public BracketTick() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling()) {
            throw new ForthException("Can't use ['] if you are not compiling.");
        }
        String wordName=is.getInputStream().readWord();
        if(!is.getCurrentDictionary().hasWord(wordName)) {
            throw new ForthException("Can't find \""+wordName+"\"");
        }
        int xt=is.getCurrentDictionary().getExecutionToken(wordName);
        
        is.getCurrentMemory().store(is.getHere(), new StaticPushData(xt));
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return "[']";
    }
        
    public boolean isImmediate() {
        return true;
    }
}
