/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class Create extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public Create() {
    }

    public void execute(VmStatus is) throws ForthException {
        
        String wordName=is.getInputStream().readWord();
        is.getCurrentDictionary().getActiveVocabulary().registerWord(wordName, is.getHere(), false);
        
        // Encode create mark
        is.getCurrentMemory().store(is.getHere(), new Comment("create mark"));
        is.setHere(is.getHere()+1);
        // Encode push address
        is.getCurrentMemory().store(is.getHere(), new StaticPushData(is.getHere()+4));
        is.setHere(is.getHere()+1);
        // Encode return
        is.getCurrentMemory().store(is.getHere(), new ReturnPrimitive());
        is.setHere(is.getHere()+1);
        // Reserve space for does>
        is.getCurrentMemory().store(is.getHere(), new Comment("nop"));
        is.setHere(is.getHere()+1);
        is.getCurrentMemory().store(is.getHere(), new Comment("nop"));
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return "create";
    }
        
    public boolean isImmediate() {
        return false;
    }
}
