/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticJump;
import leonardoce.forth.vm.primitives.StaticPushRet;

/**
 * Internal primitive
 * @author leonardo
 */
public class DoDoes extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public DoDoes() {
    }

    public void execute(VmStatus is) throws ForthException {
        // Extend the Xt of the latest create definition
        // Find the latest create definition
        
        int latestCreate=-1;
        for(int i=is.getHere()-1;i>=0;i--) {
            if(is.getCurrentMemory().get(i) instanceof Comment) {
                Comment c=(Comment)is.getCurrentMemory().get(i);
                if(c.getContents().equals("create mark")) {
                    latestCreate=i;
                    break;
                }
            }
        }
        
        if(latestCreate==-1) {
            throw new ForthException("Cannot find latest create definition");
        }
        
        // Replace the XT
        is.getCurrentMemory().store(latestCreate+2, new StaticPushRet(latestCreate+4));
        is.getCurrentMemory().store(latestCreate+3, new StaticJump(is.getHere()));
        is.getCurrentMemory().store(latestCreate+4, new ReturnPrimitive());
        
        // Copy the remaining compiled instructions
        is.getCurrentMemory().store(is.getHere(), new Comment("Created by does>"));
        is.setHere(is.getHere()+1);

        is.getCurrentMemory().store(is.getHere(), new StaticJump(is.getProgramCounter()));
        is.setHere(is.getHere()+1);
        
        int currentAddress=is.getProgramCounter()+1;
        while(!(is.getCurrentMemory().get(is.getProgramCounter()) instanceof ReturnPrimitive))
        {
            is.setProgramCounter(is.getProgramCounter()+1);
        }        
    }

    public String getName() {
        return "dodoes";
    }
}
