/*
 * Colon.java
 *
 * Created on 17 agosto 2007, 21.15
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package leonardoce.forth.vm.primitives.sys;

import leonardoce.forth.ForthException;
import leonardoce.forth.vm.AbstractPrimitive;
import leonardoce.forth.vm.VmStatus;
import leonardoce.forth.vm.primitives.ReturnPrimitive;
import leonardoce.forth.vm.primitives.StaticCall;
import leonardoce.forth.vm.primitives.StaticPushData;

/**
 *
 * @author leonardo
 */
public class PostPone extends AbstractPrimitive {    
    /** Creates a new instance of Colon */
    public PostPone() {
    }

    public void execute(VmStatus is) throws ForthException {
        if(!is.isCompiling())
        {
            throw new ForthException("Can't use postpone if you are not compiling.");
        }
        
        String wordName=is.getInputStream().readWord();
        int xt=is.getCurrentDictionary().getExecutionToken(wordName);
        is.getCurrentMemory().store(is.getHere(), new StaticCall(xt));
        is.setHere(is.getHere()+1);
    }

    public String getName() {
        return "postpone";
    }
        
    public boolean isImmediate() {
        return true;
    }
}
